org.apache.catalina.session

## Class ManagerBase

- java.lang.Object
- - org.apache.catalina.util.LifecycleBase
  - - org.apache.catalina.util.LifecycleMBeanBase
    - - org.apache.catalina.session.ManagerBase

- All Implemented Interfaces:
    MBeanRegistration, Lifecycle, Manager
  Direct Known Subclasses:
    ClusterManagerBase, PersistentManagerBase, StandardManager

      public abstract class ManagerBase
      extends LifecycleMBeanBase
      implements Manager

  Minimal implementation of the Manager interface that supports no session persistence or distributable capabilities. This class may be subclassed to create more sophisticated Manager implementations.
  Author:
    Craig R. McClanahan

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `ManagerBase.SessionTiming`

    - ### Nested classes/interfaces inherited from interface org.apache.catalina.Lifecycle

      `Lifecycle.SingleUse`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Container` | `container` The Container with which this Manager is associated.
    `protected boolean` | `distributable` Deprecated. Ignored. `Context.getDistributable()` always takes precedence. Will be removed in Tomcat 9.0.x.
    `protected int` | `duplicates`
    `protected AtomicLong` | `expiredSessions` Number of sessions that have expired.
    `protected int` | `maxActive`
    `protected int` | `maxActiveSessions` The maximum number of active Sessions allowed, or -1 for no limit.
    `protected int` | `maxInactiveInterval` Deprecated. Ignored. `Context.getSessionTimeout()` always takes precedence. Will be removed in Tomcat 9.0.x.
    `protected int` | `processExpiresFrequency` Frequency of the session expiration, and related manager operations.
    `protected long` | `processingTime` Processing time during session expiration.
    `protected int` | `rejectedSessions` Number of session creations that failed due to maxActiveSessions.
    `protected String` | `secureRandomAlgorithm` The name of the algorithm to use to create instances of `SecureRandom` which are used to generate session IDs.
    `protected String` | `secureRandomClass` The Java class name of the secure random number generator class to be used when generating session identifiers.
    `protected String` | `secureRandomProvider` The name of the provider to use to create instances of `SecureRandom` which are used to generate session IDs.
    `protected static int` | `SESSION_ID_LENGTH_UNSET`
    `protected long` | `sessionCounter`
    `protected Deque<ManagerBase.SessionTiming>` | `sessionCreationTiming`
    `protected Deque<ManagerBase.SessionTiming>` | `sessionExpirationTiming`
    `protected SessionIdGenerator` | `sessionIdGenerator`
    `protected Class<? extends SessionIdGenerator>` | `sessionIdGeneratorClass`
    `protected int` | `sessionIdLength` The session id length of Sessions created by this Manager.
    `protected int` | `sessionMaxAliveTime` The longest time (in seconds) that an expired session had been alive.
    `protected Map<String,Session>` | `sessions` The set of currently active Sessions for this Manager, keyed by session identifier.
    `protected static StringManager` | `sm` The string manager for this package.
    `protected PropertyChangeSupport` | `support` The property change support for this component.
    `protected static int` | `TIMING_STATS_CACHE_SIZE`

    - ### Fields inherited from class org.apache.catalina.util.LifecycleMBeanBase

      `mserver`

    - ### Fields inherited from interface org.apache.catalina.Lifecycle

      `AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ManagerBase()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(Session session)` Add this Session to the set of active Sessions for this Manager.
    `void` | `addPropertyChangeListener(PropertyChangeListener listener)` Add a property change listener to this component.
    `void` | `backgroundProcess()` This method will be invoked by the context/container on a periodic basis and allows the manager to implement a method that executes periodic tasks, such as expiring sessions etc.
    `void` | `changeSessionId(Session session)` Change the session ID of the current session to a new randomly generated session ID.
    `Session` | `createEmptySession()` Get a session from the recycled ones or create a new empty one.
    `Session` | `createSession(String sessionId)` Construct and return a new session object, based on the default settings specified by this Manager's properties.
    `void` | `expireSession(String sessionId)`
    `Session` | `findSession(String id)` Return the active Session, associated with this Manager, with the specified session id (if any); otherwise return `null`.
    `Session[]` | `findSessions()` Return the set of active Sessions associated with this Manager.
    `protected String` | `generateSessionId()` Generate and return a new session identifier.
    `int` | `getActiveSessions()` Gets the number of currently active sessions.
    `String` | `getClassName()`
    `Container` | `getContainer()` Return the Container with which this Manager is associated.
    `String` | `getCreationTime(String sessionId)`
    `long` | `getCreationTimestamp(String sessionId)`
    `boolean` | `getDistributable()` Deprecated.
    `String` | `getDomainInternal()` Method implemented by sub-classes to identify the domain in which MBeans should be registered.
    `int` | `getDuplicates()` Number of duplicated session IDs generated by the random source.
    `Engine` | `getEngine()` Retrieve the enclosing Engine for this Manager.
    `long` | `getExpiredSessions()` Gets the number of sessions that have expired.
    `String` | `getInfo()` Deprecated.
    `String` | `getJvmRoute()` Retrieve the JvmRoute for the enclosing Engine.
    `String` | `getLastAccessedTime(String sessionId)`
    `long` | `getLastAccessedTimestamp(String sessionId)`
    `int` | `getMaxActive()` Gets the maximum number of sessions that have been active at the same time.
    `int` | `getMaxActiveSessions()`
    `int` | `getMaxInactiveInterval()` Return the default maximum inactive interval (in seconds) for Sessions created by this Manager.
    `String` | `getName()`
    `protected StandardSession` | `getNewSession()` Get new session class to be used in the doLoad() method.
    `String` | `getObjectNameKeyProperties()` Allow sub-classes to specify the key properties component of the `ObjectName` that will be used to register this component.
    `int` | `getProcessExpiresFrequency()`
    `long` | `getProcessingTime()`
    `int` | `getRejectedSessions()` Gets the number of sessions that were not created because the maximum number of active sessions was reached.
    `String` | `getSecureRandomAlgorithm()`
    `String` | `getSecureRandomClass()`
    `String` | `getSecureRandomProvider()`
    `HashMap<String,String>` | `getSession(String sessionId)` Returns information about the session with the given session id.
    `String` | `getSessionAttribute(String sessionId, String key)` For debugging.
    `String` | `getSessionAttributeNameFilter()` Obtain the regular expression used to filter session attribute based on attribute name.
    `protected Pattern` | `getSessionAttributeNamePattern()`
    `String` | `getSessionAttributeValueClassNameFilter()` Obtain the regular expression used to filter session attribute based on the implementation class of the value.
    `protected Pattern` | `getSessionAttributeValueClassNamePattern()` Provides `getSessionAttributeValueClassNameFilter()` as a pre-compiled regular expression pattern.
    `int` | `getSessionAverageAliveTime()` Gets the average time (in seconds) that expired sessions had been alive.
    `long` | `getSessionCounter()` Returns the total number of sessions created by this manager.
    `int` | `getSessionCreateRate()` Gets the current rate of session creation (in session per minute).
    `int` | `getSessionExpireRate()` Gets the current rate of session expiration (in session per minute).
    `SessionIdGenerator` | `getSessionIdGenerator()` Gets the session id generator.
    `int` | `getSessionIdLength()` Deprecated. Use `SessionIdGenerator.getSessionIdLength()`. This method will be removed in Tomcat 9 onwards.
    `int` | `getSessionMaxAliveTime()` Gets the longest time (in seconds) that an expired session had been alive.
    `String` | `getThisAccessedTime(String sessionId)`
    `long` | `getThisAccessedTimestamp(String sessionId)`
    `boolean` | `getWarnOnSessionAttributeFilterFailure()` Should a warn level log message be generated if a session attribute is not persisted / replicated / restored.
    `protected void` | `initInternal()` Sub-classes wishing to perform additional initialization should override this method, ensuring that super.initInternal() is the first call in the overriding method.
    `String` | `listSessionIds()` For debugging.
    `void` | `processExpires()` Invalidate all sessions that have expired.
    `void` | `remove(Session session)` Remove this Session from the active Sessions for this Manager.
    `void` | `remove(Session session, boolean update)` Remove this Session from the active Sessions for this Manager.
    `void` | `removePropertyChangeListener(PropertyChangeListener listener)` Remove a property change listener from this component.
    `void` | `setContainer(Container container)` Set the Container with which this Manager is associated.
    `void` | `setDistributable(boolean distributable)` Deprecated.
    `void` | `setDuplicates(int duplicates)`
    `void` | `setExpiredSessions(long expiredSessions)` Sets the number of sessions that have expired.
    `void` | `setMaxActive(int maxActive)` (Re)sets the maximum number of sessions that have been active at the same time.
    `void` | `setMaxActiveSessions(int max)` Set the maximum number of active Sessions allowed, or -1 for no limit.
    `void` | `setMaxInactiveInterval(int interval)` Deprecated.
    `void` | `setProcessExpiresFrequency(int processExpiresFrequency)` Set the manager checks frequency.
    `void` | `setProcessingTime(long processingTime)`
    `void` | `setSecureRandomAlgorithm(String secureRandomAlgorithm)` Set the secure random number generator algorithm name.
    `void` | `setSecureRandomClass(String secureRandomClass)` Set the secure random number generator class name.
    `void` | `setSecureRandomProvider(String secureRandomProvider)` Set the secure random number generator provider name.
    `void` | `setSessionAttributeNameFilter(String sessionAttributeNameFilter)`
    `void` | `setSessionAttributeValueClassNameFilter(String sessionAttributeValueClassNameFilter)` Set the regular expression to use to filter classes used for session attributes.
    `void` | `setSessionCounter(long sessionCounter)` Sets the total number of sessions created by this manager.
    `void` | `setSessionIdGenerator(SessionIdGenerator sessionIdGenerator)`
    `void` | `setSessionIdLength(int idLength)` Deprecated. Use `SessionIdGenerator.setSessionIdLength(int)`. This method will be removed in Tomcat 9 onwards.
    `void` | `setSessionMaxAliveTime(int sessionMaxAliveTime)` Sets the longest time (in seconds) that an expired session had been alive.
    `void` | `setWarnOnSessionAttributeFilterFailure(boolean warnOnSessionAttributeFilterFailure)` Configure whether or not a warn level log message should be generated if a session attribute is not persisted / replicated / restored.
    `protected void` | `startInternal()` Sub-classes must ensure that the state is changed to `LifecycleState.STARTING` during the execution of this method.
    `protected void` | `stopInternal()` Sub-classes must ensure that the state is changed to `LifecycleState.STOPPING` during the execution of this method.
    `String` | `toString()`
    `void` | `updateSessionMaxAliveTime(int sessionAliveTime)` Updates the sessionMaxAliveTime attribute if the candidate value is larger than the current value.
    `boolean` | `willAttributeDistribute(String name, Object value)` Would the Manager distribute the given session attribute?

    - ### Methods inherited from class org.apache.catalina.util.LifecycleMBeanBase

      `destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister`

    - ### Methods inherited from class org.apache.catalina.util.LifecycleBase

      `addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, init, removeLifecycleListener, setState, setState, start, stop`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.catalina.Manager

      `load, unload`

- - ### Field Detail

    - #### container

          protected Container container

      The Container with which this Manager is associated.

    - #### distributable

          @Deprecated
          protected boolean distributable

      Deprecated. Ignored. `Context.getDistributable()` always takes precedence. Will be removed in Tomcat 9.0.x.
      The distributable flag for Sessions created by this Manager. If this flag is set to `true`, any user attributes added to a session controlled by this Manager must be Serializable.

    - #### maxInactiveInterval

          @Deprecated
          protected int maxInactiveInterval

      Deprecated. Ignored. `Context.getSessionTimeout()` always takes precedence. Will be removed in Tomcat 9.0.x.
      The default maximum inactive interval for Sessions created by this Manager.

    - #### SESSION_ID_LENGTH_UNSET

          protected static final int SESSION_ID_LENGTH_UNSET

      See Also:
        Constant Field Values

    - #### sessionIdLength

          protected int sessionIdLength

      The session id length of Sessions created by this Manager. The length should be set directly on the SessionIdGenerator. Setting it here is deprecated.

    - #### secureRandomClass

          protected String secureRandomClass

      The Java class name of the secure random number generator class to be used when generating session identifiers. The random number generator class must be self-seeding and have a zero-argument constructor. If not specified, an instance of `SecureRandom` will be generated.

    - #### secureRandomAlgorithm

          protected String secureRandomAlgorithm

      The name of the algorithm to use to create instances of `SecureRandom` which are used to generate session IDs. If no algorithm is specified, SHA1PRNG is used. To use the platform default (which may be SHA1PRNG), specify the empty string. If an invalid algorithm and/or provider is specified the SecureRandom instances will be created using the defaults. If that fails, the SecureRandom instances will be created using platform defaults.

    - #### secureRandomProvider

          protected String secureRandomProvider

      The name of the provider to use to create instances of `SecureRandom` which are used to generate session IDs. If no algorithm is specified the of SHA1PRNG default is used. If an invalid algorithm and/or provider is specified the SecureRandom instances will be created using the defaults. If that fails, the SecureRandom instances will be created using platform defaults.

    - #### sessionIdGenerator

          protected SessionIdGenerator sessionIdGenerator

    - #### sessionIdGeneratorClass

          protected Class<? extends SessionIdGenerator> sessionIdGeneratorClass

    - #### sessionMaxAliveTime

          protected volatile int sessionMaxAliveTime

      The longest time (in seconds) that an expired session had been alive.

    - #### TIMING_STATS_CACHE_SIZE

          protected static final int TIMING_STATS_CACHE_SIZE

      See Also:
        Constant Field Values

    - #### sessionCreationTiming

          protected final Deque<ManagerBase.SessionTiming> sessionCreationTiming

    - #### sessionExpirationTiming

          protected final Deque<ManagerBase.SessionTiming> sessionExpirationTiming

    - #### expiredSessions

          protected final AtomicLong expiredSessions

      Number of sessions that have expired.

    - #### sessions

          protected Map<String,Session> sessions

      The set of currently active Sessions for this Manager, keyed by session identifier.

    - #### sessionCounter

          protected long sessionCounter

    - #### maxActive

          protected volatile int maxActive

    - #### maxActiveSessions

          protected int maxActiveSessions

      The maximum number of active Sessions allowed, or -1 for no limit.

    - #### rejectedSessions

          protected int rejectedSessions

      Number of session creations that failed due to maxActiveSessions.

    - #### duplicates

          protected volatile int duplicates

    - #### processingTime

          protected long processingTime

      Processing time during session expiration.

    - #### processExpiresFrequency

          protected int processExpiresFrequency

      Frequency of the session expiration, and related manager operations. Manager operations will be done once for the specified amount of backgroundProcess calls (ie, the lower the amount, the most often the checks will occur).

    - #### sm

          protected static final StringManager sm

      The string manager for this package.

    - #### support

          protected final PropertyChangeSupport support

      The property change support for this component.

  - ### Constructor Detail

    - #### ManagerBase

          public ManagerBase()

  - ### Method Detail

    - #### getSessionAttributeNameFilter

          public String getSessionAttributeNameFilter()

      Obtain the regular expression used to filter session attribute based on attribute name. The regular expression is anchored so it must match the entire name
      Returns:
        The regular expression currently used to filter attribute names. `null` means no filter is applied. If an empty string is specified then no names will match the filter and all attributes will be blocked.

    - #### setSessionAttributeNameFilter

          public void setSessionAttributeNameFilter(String sessionAttributeNameFilter)

    - #### getSessionAttributeNamePattern

          protected Pattern getSessionAttributeNamePattern()

    - #### getSessionAttributeValueClassNameFilter

          public String getSessionAttributeValueClassNameFilter()

      Obtain the regular expression used to filter session attribute based on the implementation class of the value. The regular expression is anchored and must match the fully qualified class name.
      Returns:
        The regular expression currently used to filter class names. `null` means no filter is applied. If an empty string is specified then no names will match the filter and all attributes will be blocked.

    - #### getSessionAttributeValueClassNamePattern

          protected Pattern getSessionAttributeValueClassNamePattern()

      Provides `getSessionAttributeValueClassNameFilter()` as a pre-compiled regular expression pattern.
      Returns:
        The pre-compiled pattern used to filter session attributes based on the implementation class name of the value. `null` means no filter is applied.

    - #### setSessionAttributeValueClassNameFilter

          public void setSessionAttributeValueClassNameFilter(String sessionAttributeValueClassNameFilter)
                                                       throws PatternSyntaxException

      Set the regular expression to use to filter classes used for session attributes. The regular expression is anchored and must match the fully qualified class name.
      Parameters:
        `sessionAttributeValueClassNameFilter` - The regular expression to use to filter session attributes based on class name. Use `null` if no filtering is required. If an empty string is specified then no names will match the filter and all attributes will be blocked.
      Throws:
        `PatternSyntaxException` - If the expression is not valid

    - #### getWarnOnSessionAttributeFilterFailure

          public boolean getWarnOnSessionAttributeFilterFailure()

      Should a warn level log message be generated if a session attribute is not persisted / replicated / restored.
      Returns:
        `true` if a warn level log message should be generated

    - #### setWarnOnSessionAttributeFilterFailure

          public void setWarnOnSessionAttributeFilterFailure(boolean warnOnSessionAttributeFilterFailure)

      Configure whether or not a warn level log message should be generated if a session attribute is not persisted / replicated / restored.
      Parameters:
        `warnOnSessionAttributeFilterFailure` - `true` if the warn level message should be generated

    - #### getContainer

          public Container getContainer()

      Description copied from interface: `Manager`
      Return the Container with which this Manager is associated.
      Specified by:
        `getContainer` in interface `Manager`

    - #### setContainer

          public void setContainer(Container container)

      Description copied from interface: `Manager`
      Set the Container with which this Manager is associated. The Container must be set to a non-null value before the Manager is first used. Multiple calls to this method before first use are permitted. Once the Manager has been used, this method may not be used to change the Container (including setting a `null` value) that the Manager is associated with.
      Specified by:
        `setContainer` in interface `Manager`
      Parameters:
        `container` - The newly associated Container

    - #### getClassName

          public String getClassName()

      Returns:
        The name of the implementation class.

    - #### getDistributable

          @Deprecated
          public boolean getDistributable()

      Deprecated.
      Description copied from interface: `Manager`
      Return the distributable flag for the sessions supported by this Manager.
      Specified by:
        `getDistributable` in interface `Manager`

    - #### setDistributable

          @Deprecated
          public void setDistributable(boolean distributable)

      Deprecated.
      Description copied from interface: `Manager`
      Set the distributable flag for the sessions supported by this Manager. If this flag is set, all user data objects added to sessions associated with this manager must implement Serializable.
      Specified by:
        `setDistributable` in interface `Manager`
      Parameters:
        `distributable` - The new distributable flag

    - #### getInfo

          @Deprecated
          public String getInfo()

      Deprecated.
      Description copied from interface: `Manager`
      Return descriptive information about this Manager implementation and the corresponding version number, in the format `<description>/<version>`.
      Specified by:
        `getInfo` in interface `Manager`

    - #### getMaxInactiveInterval

          public int getMaxInactiveInterval()

      Description copied from interface: `Manager`
      Return the default maximum inactive interval (in seconds) for Sessions created by this Manager.
      Specified by:
        `getMaxInactiveInterval` in interface `Manager`

    - #### setMaxInactiveInterval

          @Deprecated
          public void setMaxInactiveInterval(int interval)

      Deprecated.
      Description copied from interface: `Manager`
      Set the default maximum inactive interval (in seconds) for Sessions created by this Manager.
      Specified by:
        `setMaxInactiveInterval` in interface `Manager`
      Parameters:
        `interval` - The new default value

    - #### getSessionIdLength

          @Deprecated
          public int getSessionIdLength()

      Deprecated. Use `SessionIdGenerator.getSessionIdLength()`. This method will be removed in Tomcat 9 onwards.
      Gets the session id length (in bytes) of Sessions created by this Manager.
      Specified by:
        `getSessionIdLength` in interface `Manager`
      Returns:
        The session id length

    - #### setSessionIdLength

          @Deprecated
          public void setSessionIdLength(int idLength)

      Deprecated. Use `SessionIdGenerator.setSessionIdLength(int)`. This method will be removed in Tomcat 9 onwards.
      Sets the session id length (in bytes) for Sessions created by this Manager.
      Specified by:
        `setSessionIdLength` in interface `Manager`
      Parameters:
        `idLength` - The session id length

    - #### getSessionIdGenerator

          public SessionIdGenerator getSessionIdGenerator()

      Gets the session id generator.
      Returns:
        The session id generator

    - #### setSessionIdGenerator

          public void setSessionIdGenerator(SessionIdGenerator sessionIdGenerator)

    - #### getName

          public String getName()

      Returns:
        The descriptive short name of this Manager implementation.

    - #### getSecureRandomClass

          public String getSecureRandomClass()

      Returns:
        The secure random number generator class name.

    - #### setSecureRandomClass

          public void setSecureRandomClass(String secureRandomClass)

      Set the secure random number generator class name.
      Parameters:
        `secureRandomClass` - The new secure random number generator class name

    - #### getSecureRandomAlgorithm

          public String getSecureRandomAlgorithm()

      Returns:
        The secure random number generator algorithm name.

    - #### setSecureRandomAlgorithm

          public void setSecureRandomAlgorithm(String secureRandomAlgorithm)

      Set the secure random number generator algorithm name.
      Parameters:
        `secureRandomAlgorithm` - The new secure random number generator algorithm name

    - #### getSecureRandomProvider

          public String getSecureRandomProvider()

      Returns:
        The secure random number generator provider name.

    - #### setSecureRandomProvider

          public void setSecureRandomProvider(String secureRandomProvider)

      Set the secure random number generator provider name.
      Parameters:
        `secureRandomProvider` - The new secure random number generator provider name

    - #### getRejectedSessions

          public int getRejectedSessions()

      Description copied from interface: `Manager`
      Gets the number of sessions that were not created because the maximum number of active sessions was reached.
      Specified by:
        `getRejectedSessions` in interface `Manager`
      Returns:
        Number of rejected sessions

    - #### getExpiredSessions

          public long getExpiredSessions()

      Description copied from interface: `Manager`
      Gets the number of sessions that have expired.
      Specified by:
        `getExpiredSessions` in interface `Manager`
      Returns:
        Number of sessions that have expired

    - #### setExpiredSessions

          public void setExpiredSessions(long expiredSessions)

      Description copied from interface: `Manager`
      Sets the number of sessions that have expired.
      Specified by:
        `setExpiredSessions` in interface `Manager`
      Parameters:
        `expiredSessions` - Number of sessions that have expired

    - #### getProcessingTime

          public long getProcessingTime()

    - #### setProcessingTime

          public void setProcessingTime(long processingTime)

    - #### getProcessExpiresFrequency

          public int getProcessExpiresFrequency()

      Returns:
        The frequency of manager checks.

    - #### setProcessExpiresFrequency

          public void setProcessExpiresFrequency(int processExpiresFrequency)

      Set the manager checks frequency.
      Parameters:
        `processExpiresFrequency` - the new manager checks frequency

    - #### backgroundProcess

          public void backgroundProcess()

      This method will be invoked by the context/container on a periodic basis and allows the manager to implement a method that executes periodic tasks, such as expiring sessions etc.

      Direct call to `processExpires()`

      Specified by:
        `backgroundProcess` in interface `Manager`

    - #### processExpires

          public void processExpires()

      Invalidate all sessions that have expired.

    - #### initInternal

          protected void initInternal()
                               throws LifecycleException

      Description copied from class: `LifecycleMBeanBase`
      Sub-classes wishing to perform additional initialization should override this method, ensuring that super.initInternal() is the first call in the overriding method.
      Overrides:
        `initInternal` in class `LifecycleMBeanBase`
      Throws:
        `LifecycleException`

    - #### startInternal

          protected void startInternal()
                                throws LifecycleException

      Description copied from class: `LifecycleBase`
      Sub-classes must ensure that the state is changed to `LifecycleState.STARTING` during the execution of this method. Changing state will trigger the `Lifecycle.START_EVENT` event. If a component fails to start it may either throw a `LifecycleException` which will cause it's parent to fail to start or it can place itself in the error state in which case `LifecycleBase.stop()` will be called on the failed component but the parent component will continue to start normally.
      Specified by:
        `startInternal` in class `LifecycleBase`
      Throws:
        `LifecycleException`

    - #### stopInternal

          protected void stopInternal()
                               throws LifecycleException

      Description copied from class: `LifecycleBase`
      Sub-classes must ensure that the state is changed to `LifecycleState.STOPPING` during the execution of this method. Changing state will trigger the `Lifecycle.STOP_EVENT` event.
      Specified by:
        `stopInternal` in class `LifecycleBase`
      Throws:
        `LifecycleException`

    - #### add

          public void add(Session session)

      Description copied from interface: `Manager`
      Add this Session to the set of active Sessions for this Manager.
      Specified by:
        `add` in interface `Manager`
      Parameters:
        `session` - Session to be added

    - #### addPropertyChangeListener

          public void addPropertyChangeListener(PropertyChangeListener listener)

      Description copied from interface: `Manager`
      Add a property change listener to this component.
      Specified by:
        `addPropertyChangeListener` in interface `Manager`
      Parameters:
        `listener` - The listener to add

    - #### createSession

          public Session createSession(String sessionId)

      Description copied from interface: `Manager`
      Construct and return a new session object, based on the default settings specified by this Manager's properties. The session id specified will be used as the session id. If a new session cannot be created for any reason, return `null`.
      Specified by:
        `createSession` in interface `Manager`
      Parameters:
        `sessionId` - The session id which should be used to create the new session; if `null`, the session id will be assigned by this method, and available via the getId() method of the returned session.

    - #### createEmptySession

          public Session createEmptySession()

      Description copied from interface: `Manager`
      Get a session from the recycled ones or create a new empty one. The PersistentManager manager does not need to create session data because it reads it from the Store.
      Specified by:
        `createEmptySession` in interface `Manager`

    - #### findSession

          public Session findSession(String id)
                              throws IOException

      Description copied from interface: `Manager`
      Return the active Session, associated with this Manager, with the specified session id (if any); otherwise return `null`.
      Specified by:
        `findSession` in interface `Manager`
      Parameters:
        `id` - The session id for the session to be returned
      Throws:
        `IOException` - if an input/output error occurs while processing this request

    - #### findSessions

          public Session[] findSessions()

      Description copied from interface: `Manager`
      Return the set of active Sessions associated with this Manager. If this Manager has no active Sessions, a zero-length array is returned.
      Specified by:
        `findSessions` in interface `Manager`

    - #### remove

          public void remove(Session session)

      Description copied from interface: `Manager`
      Remove this Session from the active Sessions for this Manager.
      Specified by:
        `remove` in interface `Manager`
      Parameters:
        `session` - Session to be removed

    - #### remove

          public void remove(Session session,
                    boolean update)

      Description copied from interface: `Manager`
      Remove this Session from the active Sessions for this Manager.
      Specified by:
        `remove` in interface `Manager`
      Parameters:
        `session` - Session to be removed
        `update` - Should the expiration statistics be updated

    - #### removePropertyChangeListener

          public void removePropertyChangeListener(PropertyChangeListener listener)

      Description copied from interface: `Manager`
      Remove a property change listener from this component.
      Specified by:
        `removePropertyChangeListener` in interface `Manager`
      Parameters:
        `listener` - The listener to remove

    - #### changeSessionId

          public void changeSessionId(Session session)

      Description copied from interface: `Manager`
      Change the session ID of the current session to a new randomly generated session ID.
      Specified by:
        `changeSessionId` in interface `Manager`
      Parameters:
        `session` - The session to change the session ID for

    - #### willAttributeDistribute

          public boolean willAttributeDistribute(String name,
                                        Object value)

      Would the Manager distribute the given session attribute? Manager implementations may provide additional configuration options to control which attributes are distributable.

      This implementation excludes session attributes from distribution if the:

      - attribute name matches `getSessionAttributeNameFilter()`
      Specified by:
        `willAttributeDistribute` in interface `Manager`
      Parameters:
        `name` - The attribute name
        `value` - The attribute value
      Returns:
        `true` if the Manager would distribute the given attribute otherwise `false`

    - #### getNewSession

          protected StandardSession getNewSession()

      Get new session class to be used in the doLoad() method.

    - #### generateSessionId

          protected String generateSessionId()

      Generate and return a new session identifier.

    - #### getEngine

          public Engine getEngine()

      Retrieve the enclosing Engine for this Manager.
      Returns:
        an Engine object (or null).

    - #### getJvmRoute

          public String getJvmRoute()

      Retrieve the JvmRoute for the enclosing Engine.
      Returns:
        the JvmRoute or null.

    - #### setSessionCounter

          public void setSessionCounter(long sessionCounter)

      Description copied from interface: `Manager`
      Sets the total number of sessions created by this manager.
      Specified by:
        `setSessionCounter` in interface `Manager`
      Parameters:
        `sessionCounter` - Total number of sessions created by this manager.

    - #### getSessionCounter

          public long getSessionCounter()

      Description copied from interface: `Manager`
      Returns the total number of sessions created by this manager.
      Specified by:
        `getSessionCounter` in interface `Manager`
      Returns:
        Total number of sessions created by this manager.

    - #### getDuplicates

          public int getDuplicates()

      Number of duplicated session IDs generated by the random source. Anything bigger than 0 means problems.
      Returns:
        The count of duplicates

    - #### setDuplicates

          public void setDuplicates(int duplicates)

    - #### getActiveSessions

          public int getActiveSessions()

      Description copied from interface: `Manager`
      Gets the number of currently active sessions.
      Specified by:
        `getActiveSessions` in interface `Manager`
      Returns:
        Number of currently active sessions

    - #### getMaxActive

          public int getMaxActive()

      Description copied from interface: `Manager`
      Gets the maximum number of sessions that have been active at the same time.
      Specified by:
        `getMaxActive` in interface `Manager`
      Returns:
        Maximum number of sessions that have been active at the same time

    - #### setMaxActive

          public void setMaxActive(int maxActive)

      Description copied from interface: `Manager`
      (Re)sets the maximum number of sessions that have been active at the same time.
      Specified by:
        `setMaxActive` in interface `Manager`
      Parameters:
        `maxActive` - Maximum number of sessions that have been active at the same time.

    - #### getMaxActiveSessions

          public int getMaxActiveSessions()

      Returns:
        The maximum number of active Sessions allowed, or -1 for no limit.

    - #### setMaxActiveSessions

          public void setMaxActiveSessions(int max)

      Set the maximum number of active Sessions allowed, or -1 for no limit.
      Parameters:
        `max` - The new maximum number of sessions

    - #### getSessionMaxAliveTime

          public int getSessionMaxAliveTime()

      Description copied from interface: `Manager`
      Gets the longest time (in seconds) that an expired session had been alive.
      Specified by:
        `getSessionMaxAliveTime` in interface `Manager`
      Returns:
        Longest time (in seconds) that an expired session had been alive.

    - #### setSessionMaxAliveTime

          public void setSessionMaxAliveTime(int sessionMaxAliveTime)

      Description copied from interface: `Manager`
      Sets the longest time (in seconds) that an expired session had been alive.
      Specified by:
        `setSessionMaxAliveTime` in interface `Manager`
      Parameters:
        `sessionMaxAliveTime` - Longest time (in seconds) that an expired session had been alive.

    - #### updateSessionMaxAliveTime

          public void updateSessionMaxAliveTime(int sessionAliveTime)

      Updates the sessionMaxAliveTime attribute if the candidate value is larger than the current value.
      Parameters:
        `sessionAliveTime` - The candidate value (in seconds) for the new sessionMaxAliveTime value.

    - #### getSessionAverageAliveTime

          public int getSessionAverageAliveTime()

      Gets the average time (in seconds) that expired sessions had been alive. This may be based on sample data.

      Based on the last 100 sessions to expire. If less than 100 sessions have expired then all available data is used.

      Specified by:
        `getSessionAverageAliveTime` in interface `Manager`
      Returns:
        Average time (in seconds) that expired sessions had been alive.

    - #### getSessionCreateRate

          public int getSessionCreateRate()

      Gets the current rate of session creation (in session per minute). This may be based on sample data.

      Based on the creation time of the previous 100 sessions created. If less than 100 sessions have been created then all available data is used.

      Specified by:
        `getSessionCreateRate` in interface `Manager`
      Returns:
        The current rate (in sessions per minute) of session creation

    - #### getSessionExpireRate

          public int getSessionExpireRate()

      Gets the current rate of session expiration (in session per minute). This may be based on sample data

      Based on the expiry time of the previous 100 sessions expired. If less than 100 sessions have expired then all available data is used.

      Specified by:
        `getSessionExpireRate` in interface `Manager`
      Returns:
        The current rate (in sessions per minute) of session expiration

    - #### listSessionIds

          public String listSessionIds()

      For debugging.
      Returns:
        A space separated list of all session IDs currently active

    - #### getSessionAttribute

          public String getSessionAttribute(String sessionId,
                                   String key)

      For debugging.
      Parameters:
        `sessionId` - The ID for the session of interest
        `key` - The key for the attribute to obtain
      Returns:
        The attribute value for the specified session, if found, null otherwise

    - #### getSession

          public HashMap<String,String> getSession(String sessionId)

      Returns information about the session with the given session id.

      The session information is organized as a HashMap, mapping session attribute names to the String representation of their values.

      Parameters:
        `sessionId` - Session id
      Returns:
        HashMap mapping session attribute names to the String representation of their values, or null if no session with the specified id exists, or if the session does not have any attributes

    - #### expireSession

          public void expireSession(String sessionId)

    - #### getThisAccessedTimestamp

          public long getThisAccessedTimestamp(String sessionId)

    - #### getThisAccessedTime

          public String getThisAccessedTime(String sessionId)

    - #### getLastAccessedTimestamp

          public long getLastAccessedTimestamp(String sessionId)

    - #### getLastAccessedTime

          public String getLastAccessedTime(String sessionId)

    - #### getCreationTime

          public String getCreationTime(String sessionId)

    - #### getCreationTimestamp

          public long getCreationTimestamp(String sessionId)

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getObjectNameKeyProperties

          public String getObjectNameKeyProperties()

      Description copied from class: `LifecycleMBeanBase`
      Allow sub-classes to specify the key properties component of the `ObjectName` that will be used to register this component.
      Specified by:
        `getObjectNameKeyProperties` in class `LifecycleMBeanBase`
      Returns:
        The string representation of the key properties component of the desired `ObjectName`

    - #### getDomainInternal

          public String getDomainInternal()

      Description copied from class: `LifecycleMBeanBase`
      Method implemented by sub-classes to identify the domain in which MBeans should be registered.
      Specified by:
        `getDomainInternal` in class `LifecycleMBeanBase`
      Returns:
        The name of the domain to use to register MBeans.

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.